<?php

/* DISCLAIMER *****************************************************************
*                                                                             *
* The Guest Bookcode is distributed without any warranty. All      *
* warranties, expressed or implied are hereby disclaimed. This includes but   *
* is not limited to warranties of merchantability or fitness for a particular *
* purpose. The reselling of this code is strictly prohibited.                 *
*                                                                             *
*******************************************************************************

/* Guest BookINFORMATION *******************************************
*                                                                             *
* URL:           www.purpleyin.com                                            *
* AUTHOR:        Thomas Phan                                                  *
*                                                                             *
******************************************************************************/

include'PYG.php';

if(count($_POST)>0)
{
	$DB=new PYGDB();

	$fieldNames=$DB->getColumnNames();

	if(isset($_SERVER['REMOTE_ADDR']))
	{
		$_POST['ip']=$_SERVER['REMOTE_ADDR'];
	}

	if($options->get('validationRequired'))
	{
		$_POST['status']=0;
	}
	else
	{
		$_POST['status']=1;
	}

	foreach($fieldNames as $fieldName)
	{
		if(!isset($_POST[$fieldName]))
		{
			$_POST[$fieldName]='';
		}
	}

	if(!$_POST['private'])
	{
		$_POST['private']=0;
	}

	/* Build error page. */
	$templates=new PYGTEMPLATES();

	$error=false;

	$errorString=$templates->get('errorHeader');

	$perErrorTemplate=$templates->get('perError');

	/* Handle Turing protection. */
	if($options->get('turingProtection'))
	{
		session_start();

		if(!isset($_SESSION['turingString'])||!isset($_POST['userTuringString'])||$_SESSION['turingString']!=$_POST['userTuringString'])
		{
			$error=true;

			$errorString.=str_replace('<error>',$options->get('turingProtectionError'),$perErrorTemplate);
		}
	}

	/* Check for missing required fields. */
	$fields=new PYGFIELDS();

	foreach($fieldNames as $fieldName)
	{
		if(!$_POST[$fieldName]&&$fields->required($fieldName))
		{
			$error=true;

			$errorString.=str_replace('<error>',$options->get('requiredFieldError'),$perErrorTemplate);

			break;
		}
	}

	/* Check for maximum entry length being exceeded only if max entry length is greater than zero. */
	if($options->get('maxEntryLength')>0)
	{
		$entryString='';

		foreach($fieldNames as $fieldName)
		{
			$entryString.=$_POST[$fieldName];
		}

		if(strlen($entryString)>$options->get('maxEntryLength'))
		{
			$error=true;

			$errorString.=str_replace('<error>',$options->get('longEntryError'),$perErrorTemplate);
		}
	}

	/* Check for max lines limit being exceeded only if max lines limit is greater than zero. */
	if($options->get('maxLines'))
	{
		foreach($fieldNames as $fieldName)
		{
			/* Count the number of "\r\n". */
			if(substr_count($_POST[$fieldName],"\r\n")>$options->get('maxLines')-1)
			{
				$error=true;

				$errorString.=str_replace('<error>',$options->get('maxLinesError'),$perErrorTemplate);

				break;
			}
		}
	}

	/* Check for submissions from banned I.P.'s. */
	$bannedIPs=new PYGBANNEDIPS();

	if($bannedIPs->isBanned($_POST['ip']))
	{
		$error=true;

		$errorString.=str_replace('<error>',$options->get('IPError'),$perErrorTemplate);
	}

	/* Check for bad words being submitted. */
	$badWords=new PYGBADWORDS();

	foreach($fieldNames as $fieldName)
	{
		if($badWords->findBadWords($_POST[$fieldName]))
		{
			$error=true;

			$errorString.=str_replace('<error>',$options->get('badWordError'),$perErrorTemplate);

			break;
		}
	}

	/* Check for bad strings being submitted. */
	$badStrings=new PYGBADSTRINGS();

	foreach($fieldNames as $fieldName)
	{
		if($badStrings->findBadStrings($_POST[$fieldName]))
		{
			$error=true;

			$errorString.=str_replace('<error>',$options->get('badStringError'),$perErrorTemplate);

			break;
		}
	}

	/* Finish up error page. */
	$errorString.=$templates->get('errorFooter');

	$errorString=str_replace('<scriptName>',GUESTBOOK_NAME,$errorString);

	$errorString=str_replace('Guest Book',GUESTBOOK_NAME,$errorString);

	$errorString=str_replace('Guest Book',GUESTBOOK_NAME,$errorString);

	/* Remove "http://" from URL's. */
	if('http://'==strtolower(substr($_POST['homepage'],0,7)))
	{
		$_POST['homepage']=substr($_POST['homepage'],7);
	}

	/* Timestamp. Handle time offset. */
	$_POST['dateAndTime']=time()+$options->get('timeOffset');

	/* Either print errors or add entry to database. */
	if($error)
	{
		print($errorString);
	}
	else
	{
		if($options->get('emailNotification'))
		{
			$message=
				$_POST['name']."\r\n\r\n".
				$_POST['email']."\r\n\r\n".
				$_POST['homepage']."\r\n\r\n".
				$_POST['location']."\r\n\r\n".
				$_POST['comments']."\r\n\r\n".
				$_POST['extraField1']."\r\n\r\n".
				$_POST['extraField2']."\r\n\r\n".
				$_POST['extraField3']."\r\n\r\n".
				$_POST['extraField4']."\r\n\r\n".
				$_POST['extraField5']."\r\n\r\n"
			;

			if($_POST['private'])
			{
				$message.="private\r\n\r\n";
			}

			mail(
				$options->get('adminEmail'),
				'New Guestbook Entry Notification',
				$message,
				"From: ".$options->get('adminEmail')."\r\n"
			);
		}

		/* Make sure admin reply is not submitted. */
		$_POST['reply']='';

		/* Add entry to database. */
		$DB->insert($_POST);

		header('location: '.$options->get('signGoTo'));
	}
}
else
{
	header('location: sign.php');
}

?>