<?php

/* DISCLAIMER *****************************************************************
*                                                                             *
* The Guest Bookcode is distributed without any warranty. All      *
* warranties, expressed or implied are hereby disclaimed. This includes but   *
* is not limited to warranties of merchantability or fitness for a particular *
* purpose. The reselling of this code is strictly prohibited.                 *
*                                                                             *
*******************************************************************************

/* Guest BookINFORMATION *******************************************
*                                                                             *
* URL:           www.purpleyin.com                                            *
* AUTHOR:        Thomas Phan                                                  *
*                                                                             *
******************************************************************************/

include'PYG.php';

$DB=new PYGDB();

if($options->get('entryOrder'))
{
	$rows=$DB->getRows('chronological');
}
else
{
	$rows=$DB->getRows('reversechronological');
}

/* If not using private entry place holders, then remove private entries. */
if(!$options->get('privatePlaceholders'))
{
	$temp=array();

	foreach($rows as $row)
	{
		if(!$row['private'])
		{
			$temp[$row['id']]=$row;
		}
	}

	$rows=$temp;
}

/* If guestbook empty, then redirect. */
if(!count($rows))
{
	header('location: '.$options->get('emptyGoTo'));

	exit();
}

$totalEntries=count($rows);

$templates=new PYGTEMPLATES();

$entriesPerPage=$options->get('entriesPerPage');

if($options->get('spanPages')&&$totalEntries)
{
	/* Set beginning entry. */
	if(
		isset($_GET['beginningEntry'])&&				/* Must be set. */
		settype($_GET['beginningEntry'],'integer')&&	/* Must be an integer. */
		$_GET['beginningEntry']>0&&						/* Must be greater than zero. */
		$_GET['beginningEntry']<=$totalEntries			/* Must be less than or equal to the total number of entries. */
	)
	{
		/* Good. Do nothing. */
	}
	else
	{
		$_GET['beginningEntry']=1;
	}

	/* Set ending entry. */
	if(
		isset($_GET['endingEntry'])&&					/* Must be set. */
		settype($_GET['endingEntry'],'integer')&&		/* Must be an integer. */
		$_GET['endingEntry']>0&&						/* Must be greater than zero. */
		$_GET['endingEntry']>=$_GET['beginningEntry']&&	/* Must be greater than or equal to beginning entry. */
		$_GET['endingEntry']<=$totalEntries				/* Must be less than or equal to the total number of entries. */

	)
	{
		/* Good. Do nothing. */
	}
	elseif($_GET['beginningEntry']+$entriesPerPage-1<=$totalEntries)
	{
		$_GET['endingEntry']=$_GET['beginningEntry']+$entriesPerPage-1;
	}
	else
	{
		$_GET['endingEntry']=$totalEntries;
	}

	/* Set beginning entry for next page. */
	if($_GET['endingEntry']+1>$totalEntries)
	{
		$bNextPage=1;
	}
	else
	{
		$bNextPage=$_GET['endingEntry']+1;
	}

	/* Set ending entry for next page. */
	if($bNextPage+$entriesPerPage-1>$totalEntries)
	{
		$eNextPage=$totalEntries;
	}
	else
	{
		$eNextPage=$bNextPage+$entriesPerPage-1;
	}

	/* Set beginning entry for previous page. */
	if($_GET['beginningEntry']==1)
	{
		$bPreviousPage=$totalEntries-$entriesPerPage+1;
	}
	elseif($_GET['beginningEntry']-$entriesPerPage<1)
	{
		$bPreviousPage=1;
	}
	else
	{
		$bPreviousPage=$_GET['beginningEntry']-$entriesPerPage;
	}

	/* Set ending entry for previous page. */
	if($_GET['beginningEntry']==1)
	{
		$ePreviousPage=$totalEntries;
	}
	else
	{
		$ePreviousPage=$_GET['beginningEntry']-1;
	}

	/* Extract only the rows needed. */
	$rows=array_slice($rows,$_GET['beginningEntry']-1,$_GET['endingEntry']-$_GET['beginningEntry']+1);
}
elseif(!$totalEntries)
{
	$bPreviousPage=$bNextPage=$_GET['beginningEntry']=0;

	$ePreviousPage=$eNextPage=$_GET['endingEntry']=0;
}
else
{
	$bPreviousPage=$bNextPage=$_GET['beginningEntry']=1;

	$ePreviousPage=$eNextPage=$_GET['endingEntry']=$totalEntries;
}

$counter=0;

$entriesHTML='';

foreach($rows as $row)
{
	$fieldNames=$DB->getColumnNames();

	/* Handle max word length limit. */
	for($i=0;$i<count($fieldNames);$i++)
	{
		$words=explode(' ',$row[$fieldNames[$i]]);

		for($j=0;$j<count($words);$j++)
		{
			$moreWords=explode("\r\n",$words[$j]);

			for($k=0;$k<count($moreWords);$k++)
			{
				$moreWords[$k]=trim(chunk_split($moreWords[$k],$options->get('maxWordLength'),' '));
			}

			$words[$j]=implode("\r\n",$moreWords);
		}

		$row[$fieldNames[$i]]=implode(' ',$words);
	}

	/* Handle entries containing HTML. */
	if(!$options->get('allowHTML'))
	{
		foreach($fieldNames as $fieldName)
		{
			$row[$fieldName]=pyg_htmlspecialchars($row[$fieldName]);
		}
	}

	/* Handle smilies in comments and reply. */
	if($options->get('smiliesEnabled'))
	{
		$smilies=new PYGSMILIES();

		foreach($smilies->get() as $smiley)
		{
			if($smiley['advanced'])
			{
				$smileyString=$smiley['advanced'];
			}
			else
			{
				$smileyString='<img border="0" src="'.$smiley['filename'].'" alt="" />';
			}

			if($options->get('allowHTML'))
			{
				$row['comments']=str_replace($smiley['emoticon'],$smileyString,$row['comments']);
				$row['reply']=str_replace($smiley['emoticon'],$smileyString,$row['reply']);
			}
			else
			{
				$row['comments']=str_replace(pyg_htmlspecialchars($smiley['emoticon']),$smileyString,$row['comments']);
				$row['reply']=str_replace(pyg_htmlspecialchars($smiley['emoticon']),$smileyString,$row['reply']);
			}
		}
	}

	/* Replace line break with HTML line breaks. */
	foreach($fieldNames as $fieldName)
	{
		$row[$fieldName]=str_replace("\r\n",'<br />',$row[$fieldName]);
	}

	/* Handle private entry place holders. */
	if($options->get('privatePlaceholders')&&$row['private'])
	{
		$row['comments']='<a style="text-decoration:none" href="admin.php?display=adminEntries&amp;status=active&amp;beginningEntry='.($_GET['beginningEntry']+$counter).'&amp;endingEntry='.($_GET['beginningEntry']+$counter).'">View private message (Admin only).</a>';

		$row['name']=
		$row['email']=
		$row['homepage']=
		$row['location']=
		$row['ip']=
		$row['extraField1']=
		$row['extraField2']=
		$row['extraField3']=
		$row['extraField4']=
		$row['extraField5']='Private';
	}

	/* Check email validity. */
	if(strpos($row['email'],'.')===false||strpos($row['email'],'@')===false)
	{
		$emailValid=false;
	}
	else
	{
		$emailValid=true;
	}

	/* Link email if valid. */
	if($emailValid)
	{
		$emailLinked='<a href="mailto:'.$row['email'].'">'.$row['email'].'</a>';
	}
	else
	{
		$emailLinked=$row['email'];
	}

	/* Create email icon if valid. */
	if($emailValid)
	{
		$emailIcon='<a href="mailto:'.$row['email'].'"><img border="0" src="email.gif" alt="" /></a>';
	}
	else
	{
		$emailIcon='';
	}

	/* Check homepage URL validity. */
	if(strpos($row['homepage'],'.')===false)
	{
		$homepageValid=false;
	}
	else
	{
		$homepageValid=true;
	}

	/* Link homepage if valid. */
	if($homepageValid)
	{
		$homepageLinked='<a href="http://'.$row['homepage'].'">'.$row['homepage'].'</a>';
	}
	else
	{
		$homepageLinked=$row['homepage'];
	}

	/* Create homepage icons if valid. */
	if($homepageValid)
	{
		$homepageIcon='<a href="http://'.$row['homepage'].'"><img border="0" src="homepage.gif" alt="" /></a>';
		$homepageIconBlank='<a href="http://'.$row['homepage'].'" target="_blank"><img border="0" src="homepage.gif" alt="" /></a>';
		$homepageIconTop='<a href="http://'.$row['homepage'].'" target="_top"><img border="0" src="homepage.gif" alt="" /></a>';
	}
	else
	{
		$homepageIcon='';
		$homepageIconBlank='';
		$homepageIconTop='';
	}

	$entry=$templates->get('viewEntry');

	/* Parse tags. */
	$timestamp=$row['dateAndTime'];

	$months=array(
		$options->get('month1'),
		$options->get('month2'),
		$options->get('month3'),
		$options->get('month4'),
		$options->get('month5'),
		$options->get('month6'),
		$options->get('month7'),
		$options->get('month8'),
		$options->get('month9'),
		$options->get('month10'),
		$options->get('month11'),
		$options->get('month12')
	);

	$daysOfWeek=array(
		$options->get('day1'),
		$options->get('day2'),
		$options->get('day3'),
		$options->get('day4'),
		$options->get('day5'),
		$options->get('day6'),
		$options->get('day7')
	);

	$entry=str_replace('<ye>',date('Y',$timestamp),$entry);
	$entry=str_replace('<yedd>',date('y',$timestamp),$entry);
	$entry=str_replace('<mo>',date('n',$timestamp),$entry);
	$entry=str_replace('<modd>',date('m',$timestamp),$entry);
	$entry=str_replace('<month>',$months[date('n',$timestamp)-1],$entry);
	$entry=str_replace('<da>',date('j',$timestamp),$entry);
	$entry=str_replace('<dadd>',date('d',$timestamp),$entry);
	$entry=str_replace('<weekday>',$daysOfWeek[date('w',$timestamp)],$entry);
	$entry=str_replace('<ho12>',date('g',$timestamp),$entry);
	$entry=str_replace('<ho12dd>',date('h',$timestamp),$entry);
	$entry=str_replace('<ho>',date('G',$timestamp),$entry);
	$entry=str_replace('<hodd>',date('H',$timestamp),$entry);
	$entry=str_replace('<mi>',intval(date('i',$timestamp)),$entry);
	$entry=str_replace('<midd>',date('i',$timestamp),$entry);
	$entry=str_replace('<se>',intval(date('s',$timestamp)),$entry);
	$entry=str_replace('<sedd>',date('s',$timestamp),$entry);
	$entry=str_replace('<ampm>',date('a',$timestamp),$entry);

	if($options->get('entryNumbersOrder'))
	{
		$entry=str_replace('<number>',$totalEntries-($_GET['beginningEntry']+$counter++)+1,$entry);
	}
	else
	{
		$entry=str_replace('<number>',$_GET['beginningEntry']+$counter++,$entry);
	}

	$entry=str_replace('<name>',$row['name'],$entry);

	$entry=str_replace('<email>',$row['email'],$entry);

	$entry=str_replace('<emailLinked>',$emailLinked,$entry);

	$entry=str_replace('<emailIcon>',$emailIcon,$entry);

	if($emailValid)
	{
		$entry=str_replace('<emailJS>',string2JavaScript($row['email']),$entry);
		$entry=str_replace('<emailLinkedJS>',string2JavaScript($emailLinked),$entry);
		$entry=str_replace('<emailIconJS>',string2JavaScript($emailIcon),$entry);
	}
	else
	{
		$entry=str_replace('<emailJS>',$row['email'],$entry);
		$entry=str_replace('<emailLinkedJS>',$emailLinked,$entry);
		$entry=str_replace('<emailIconJS>','',$entry);
	}

	$entry=str_replace('<homepage>',$row['homepage'],$entry);

	$entry=str_replace('<homepageLinked>',$homepageLinked,$entry);

	$entry=str_replace('<homepageIcon>',$homepageIcon,$entry);

	$entry=str_replace('<homepageIconBlank>',$homepageIconBlank,$entry);

	$entry=str_replace('<homepageIconTop>',$homepageIconTop,$entry);

	$entry=str_replace('<location>',$row['location'],$entry);

	$entry=str_replace('<comments>',$row['comments'],$entry);

	$entry=str_replace('<ip>',$row['ip'],$entry);

	if($options->get('hostNameByIP'))
	{
		$entry=str_replace('<hostName>',pyg_gethostbyaddr($row['ip']),$entry);
	}
	else
	{
		$entry=str_replace('<hostName>','',$entry);
	}

	if($row['reply'])
	{
		$entry=str_replace('<reply>',str_replace('<reply>',$row['reply'],$templates->get('reply')),$entry);
	}
	else
	{
		$entry=str_replace('<reply>','',$entry);
	}

	$entry=str_replace('<extraField1>',$row['extraField1'],$entry);
	$entry=str_replace('<extraField2>',$row['extraField2'],$entry);
	$entry=str_replace('<extraField3>',$row['extraField3'],$entry);
	$entry=str_replace('<extraField4>',$row['extraField4'],$entry);
	$entry=str_replace('<extraField5>',$row['extraField5'],$entry);

	$entry=str_replace('<id>',$row['id'],$entry);

	/* Make delete URL. */
	if($_GET['beginningEntry']==$totalEntries)
	{
		$entry=str_replace('<deleteURL>','admin.php?action=deleteEntry&amp;status=active&amp;id='.$row['id'].'&amp;from=view&amp;beginningEntry='.$bPreviousPage,$entry);
	}
	else
	{
		$entry=str_replace('<deleteURL>','admin.php?action=deleteEntry&amp;status=active&amp;id='.$row['id'].'&amp;from=view&amp;beginningEntry='.$_GET['beginningEntry'],$entry);
	}

	/* Make edit URL. */
	$entry=str_replace('<editURL>','admin.php?display=editEntryForm&amp;status=active&amp;id='.$row['id'].'&amp;from=view&amp;beginningEntry='.$_GET['beginningEntry'],$entry);

	/* Make reply URL. */
	$entry=str_replace('<replyURL>','admin.php?display=replyForm&amp;status=active&amp;id='.$row['id'].'&amp;from=view&amp;beginningEntry='.$_GET['beginningEntry'],$entry);

	$entriesHTML.=$entry;
}

$buffer=$templates->get('viewHeader').$entriesHTML.$templates->get('viewFooter');

/* Additional tags to be parsed. Can appear anywhere in HTML. */
if($options->get('entryNumbersOrder'))
{
	$buffer=str_replace('<beginning>',$totalEntries-$_GET['beginningEntry']+1,$buffer);
	$buffer=str_replace('<ending>',$totalEntries-$_GET['endingEntry']+1,$buffer);
}
else
{
	$buffer=str_replace('<beginning>',$_GET['beginningEntry'],$buffer);
	$buffer=str_replace('<ending>',$_GET['endingEntry'],$buffer);
}

$buffer=str_replace('<total>',$totalEntries,$buffer);
$buffer=str_replace('<bNextPage>',$bNextPage,$buffer);
$buffer=str_replace('<bPreviousPage>',$bPreviousPage,$buffer);
$buffer=str_replace('<eNextPage>',$eNextPage,$buffer);
$buffer=str_replace('<ePreviousPage>',$ePreviousPage,$buffer);
$buffer=str_replace('<nextURL>','view.php?beginningEntry='.$bNextPage.'&amp;endingEntry='.$eNextPage,$buffer);
$buffer=str_replace('<prevURL>','view.php?beginningEntry='.$bPreviousPage.'&amp;endingEntry='.$ePreviousPage,$buffer);
$buffer=str_replace('<scriptName>',GUESTBOOK_NAME,$buffer);
$buffer=str_replace('Guest book',GUESTBOOK_NAME,$buffer);
$buffer=str_replace('Guest book',GUESTBOOK_NAME,$buffer);

print($buffer);

?>